/* 
	Killzone Kid's Exec Global (ExG) Framework
	http://killzonekid.com 
*/

class Commands 
{
	
	// type = 0; -> execute where 1st param is local
	
	class addPrimaryWeaponItem
	{
		type = 0;
		templates[] = {{"OBJECT","STRING","STRING"}};
	};
	class addSecondaryWeaponItem
	{
		type = 0;
		templates[] = {{"OBJECT","STRING","STRING"}};
	};
	class addHandgunItem
	{
		type = 0;
		templates[] = {{"OBJECT","STRING","STRING"}};
	};
	class setHit
	{
		type = 0;
		templates[] = {{"OBJECT","STRING",{"STRING","SCALAR"}}};
	};
	class setFuel
	{
		type = 0;
		templates[] = {{"OBJECT","STRING","SCALAR"}};
	};
	class addWeaponTurret
	{
		type = 0;
		templates[] = {{"OBJECT","STRING",{"OBJECT","SCALAR"}}};
	};
	class moveInDriver
	{
		type = 0;
		templates[] = {{"OBJECT","STRING","OBJECT"}};
	};
	class moveInCommander
	{
		type = 0;
		templates[] = {{"OBJECT","STRING","OBJECT"}};
	};
	class moveInTurret
	{
		type = 0;
		templates[] = {{"OBJECT","STRING",{"OBJECT","SCALAR"}}};
	};
	class moveInCargo
	{
		type = 0;
		templates[] = {
			{"OBJECT","STRING","OBJECT"},
			{"OBJECT","STRING",{"OBJECT","SCALAR"}}
		};
	};
	class setVelocity
	{
		type = 0;
		templates[] = {{"OBJECT","STRING",{"SCALAR","SCALAR","SCALAR"}}};
	};
	class setAmmo
	{
		type = 1;
		templates[] = {{"OBJECT","STRING",{"STRING","SCALAR"}}};
	};
	
	// type = 1; -> execute everywhere
	
	class cutRsc
	{
		type = 1;
		templates[] = {
			{"NULL","STRING",{"STRING","STRING"}},
			{"SCALAR","STRING",{"STRING","STRING"}},
			{"NULL","STRING",{"STRING","STRING","SCALAR"}},
			{"SCALAR","STRING",{"STRING","STRING","SCALAR"}},
			{"NULL","STRING",{"STRING","STRING","SCALAR","BOOL"}},
			{"SCALAR","STRING",{"STRING","STRING","SCALAR","BOOL"}}
		};
	};
	class setVehicleAmmo
	{
		type = 1; // exec everywhere because of multiple locality of turrets
		templates[] = {{"OBJECT","STRING",{"STRING","SCALAR"}}};
	};
	class setVehicleAmmoDef
	{
		type = 1; // exec everywhere because of multiple locality of turrets
		templates[] = {{"OBJECT","STRING",{"STRING","SCALAR"}}};
	};
	class switchMove
	{
		type = 1;
		templates[] = {{"OBJECT","STRING","STRING"}};
	};
	class hint
	{
		type = 1;
		templates[] = {
			{"NULL","STRING","STRING"},
			{"NULL","STRING","TEXT"}
		};
	};
	
	// type = 2; -> execute where extra 4th param is local
	
	class hintTarget // custom command
	{
		// "hintTarget" will execute "hint" command on only one client, 
		// where the object passed as 4th param is local 
		
		type = 2;
		templates[] = {
			{"NULL","STRING","STRING","OBJECT"},
			{"NULL","STRING","TEXT","OBJECT"}
		};
		exec = "hint";
	};
};