/* 
	Killzone Kid's Exec Global (ExG) Framework
	http://killzonekid.com
	
	Syntax:
		bool = [par1, command, par2] call KK_fnc_ExG;

	Params:
		par1 - ANYTHING
		Command - STRING
		par2 - ANYTHING
	
	Return:
		bool - BOOLEAN
		
	Example:
		[tank, "setHit", ["engine_hit",1]] call KK_fnc_EXG;
		[nil, "hint", "It works!"] call KK_fnc_EXG;
		--- custom ---
		[nil, "hintTarget", "For your eyes only", unit] call KK_fnc_EXG;
		
	Supported commands can be found in \Functions\ExG\Commands.hpp
*/

#include "defines.hqf"
private ["_cmd","_cfg","_par","_fnc","_p1","_p2","_p3","_exec"];
_cmd = _this select 1;
_cfg = (format [
	"configName _x == '%1'",
	_cmd
] configClasses (missionConfigFile >> "Commands")) select 0;
if (isNil "_cfg" || {!isClass _cfg}) exitWith {false};
_par =+ _this;
_fnc = {
	{
		if (isNil "_x") then {
			_this set [_forEachIndex, "NULL"];
		} else {
			if (typeName _x == "ARRAY") then {
				_x call _fnc;
			} else {
				_this set [_forEachIndex, typeName _x];
			};
		};
	} forEach _this;
};
_par call _fnc;
if ({
	if (_x isEqualTo _par) exitWith {1}; 
	false
} count getArray (_cfg >> "templates") == 0) exitWith {false};
_p1 = _this select 0;
_p2 = _this select 2;
_exec = getText (_cfg >> "exec");
if (_exec != "") then {_cmd = _exec};
switch (getNumber (_cfg >> "type")) do {
	case 0: {
		if (local _p1) then {
			call compile format ["_p1 %1 _p2", _cmd];
		} else {
			missionNamespace setVariable [PV_ExG_NAME, _this];
			if (isServer) then {
				owner _p1 publicVariableClient PV_ExG_NAME;
			} else {
				publicVariableServer PV_ExG_NAME;
			};
		};
		true
	};
	case 1: {
		if (isNil "___PublicCall") then {
			missionNamespace setVariable [PV_ExG_NAME, _this];
			publicVariable PV_ExG_NAME;
		};
		call compile format [
			"%1 %2 %3",
			if (isNil "_p1") then [{""},{"_p1"}],
			_cmd,
			if (isNil "_p2") then [{""},{"_p2"}]
		];
		true
	};
	case 2: {
		_p3 = _this select 3;
		if (local _p3) then {
			call compile format [
				"%1 %2 %3",
				if (isNil "_p1") then [{""},{"_p1"}],
				_cmd,
				if (isNil "_p2") then [{""},{"_p2"}]
			];
		} else {
			missionNamespace setVariable [PV_ExG_NAME, _this];
			if (isServer) then {
				owner _p3 publicVariableClient PV_ExG_NAME;
			} else {
				publicVariableServer PV_ExG_NAME;
			};
		};
		true
	};
	default {false};
};